//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Windows.Forms;

namespace Kanayomi
{
	public struct Ku
	{
		public string KamiPhrase, NakaPhrase, ShimoPhrase;
		private string KknKamiPhrase, KknNakaPhrase, KknShimoPhrase;
		public string PhraseE;

		
		public Ku(string kami, string naka, string shimo, 
			              string KknKami, string KknNaka, string KknShimo,
			              string phraseE)
		{
			KamiPhrase = kami; NakaPhrase = naka; ShimoPhrase = shimo;

			KknKamiPhrase = KknKami; KknNakaPhrase = KknNaka; 
			KknShimoPhrase = KknShimo;
			PhraseE = phraseE;
		}

		public Ku(string s)
		{
			//s̓_~[Bs̕eɊ֌WȂAȉsB
            //Ku( ){} ƂƊeϐnullɐݒ肳B
			KamiPhrase = ""; NakaPhrase = ""; ShimoPhrase = "";
			KknKamiPhrase = ""; KknNakaPhrase = ""; KknShimoPhrase = "";
			PhraseE = "";
		}

		//vpeB
		public string KknKami
		{  
			get{ return KknKamiPhrase; }
			set{ KknKamiPhrase = KamiFiveCharsCheck(value); }
		}
		public string KknNaka
		{
			get{ return KknNakaPhrase; }
			set{ KknNakaPhrase = NakaSevenCharsCheck(value); }
		}
		public string KknShimo
		{
			get { return KknShimoPhrase; }
			set { KknShimoPhrase = ShimoFiveCharsCheck(value); }
		}

		//܁AA܁@̃`FbN
		private string KamiFiveCharsCheck(string kami)
		{
			int L = kami.Length;
			try 
			{
				if (L != 5) throw new ArgumentOutOfRangeException();
			}
			catch 
			{
				//MessageBox.Show("F5ŋLĂB"); 
			}
		

			if (L != 5) kami = " ......................";
			return kami;
		}

		private  string NakaSevenCharsCheck(string naka)
		{
			int L = naka.Length;
			try 
			{
				if( L != 7) throw new ArgumentOutOfRangeException();
			}
			catch
			{
				//MessageBox.Show("F7ŋLĂB"); 
			}

			if (L != 7) naka = " ............................ ";
			return naka;

		}

		private string ShimoFiveCharsCheck(string shimo)
		{
			int L = shimo.Length;
			try 
			{
				if (L != 5) throw new ArgumentOutOfRangeException();
			}
			catch 
			{
				//MessageBox.Show("F5ŋLĂB"); 
			}
		

			if (L != 5) shimo = "......................";
			return shimo;
		}


	}//struct Ku

	public struct KuE
	{
		public string kamiE;
		public string nakaE;
		public string shimoE;
	}


}
