//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HaikuDelegateAndEvent
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            //case 0
            button0.Click += new System.EventHandler(this.ClickEvent0);
            this.nowtime0 += new NowTime0(this.DigitalClock0);

            //case 1
            ButtonClick1 buttonclick1 = new ButtonClick1(button1);
            buttonclick1.nowtime1 += new NowTime(this.DigitalClock1);

            //case 3
            ButtonClick3 buttonclick3 = new ButtonClick3(button3, label4, textBox1);
            buttonclick3.nowtime3 += new NowTime(buttonclick3.DigitalClock3);

            textBox1.Text = "";
            textBox2.Text = ""; 
        }


        //-----------------------------------------------------------------------------------------------------
        public delegate void NowTime0(int hh, int mm, int ss);
        public event NowTime0 nowtime0; 

        private void ClickEvent0(object sender, EventArgs e)
        {
            if (nowtime0 != null)
            {
                DateTime timeNow = DateTime.Now;
                int hh = timeNow.Hour;
                int mm = timeNow.Minute;
                int ss = timeNow.Second;

                nowtime0(hh, mm, ss);
            }
        }

        private void DigitalClock0(int hh, int mm, int ss)
        {
            textBox1.Text = string.Format("{0:D2} : {1:D2} : {2:D2}", hh, mm, ss);
            label1.ForeColor = Color.OrangeRed;
            label1.Text = "     g        "; //20

        }
        //------------------------------------------------------------------------------------------------------


        private void DigitalClock1(int hh, int mm, int ss)
        {
            textBox1.Text = string.Format("{0:D2} : {1:D2} : {2:D2}", hh, mm, ss);
            label2.ForeColor = Color.Blue;
            label2.Text = "r C   n      V "; //44
        }

        private void DigitalClock2(int hh, int mm, int ss)
        {
            textBox1.Text = string.Format("{0:D2} : {1:D2} : {2:D2}", hh, mm, ss);
            label3.ForeColor = Color.Green;
            label3.Text = "  J          "; //30

        }

        //case 2
        private void button2_Click(object sender, EventArgs e)
        {
            ButtonClick1 buttonclick1 = new ButtonClick1(button2);
            buttonclick1.nowtime1 += new NowTime(this.DigitalClock2);
        }

        private void button4_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            textBox2.Clear();
            label1.Text = "label1";
            label2.Text = "label2";
            label3.Text = "label3";
            label4.Text = "label4";
        }

        //----------------------------------------------------------------------------------------------------

        public delegate string TestDelegate(int hh, int mm, int ss);
        public event TestDelegate testdelegate;

        private void button5_Click(object sender, EventArgs e)
        {
            /*̎葱̓NXForm1̃RXgN^ɋLĂ悢B
              ނ낻̕B*/
            testdelegate += new TestDelegate(this.TestOfDelegate1);

            //label1.ForeColor = Color.Brown;
            label1.Text = testdelegate(100, 100, 100); //ړIdelegates
            //testdelegate(110,110,110);

            testdelegate -= new TestDelegate(this.TestOfDelegate1);

            testdelegate += new TestDelegate(this.TestOfDelegate2);

            //label2.ForeColor = Color.Orange;
            label2.Text = testdelegate(200, 200, 200);
        }

        private string TestOfDelegate1(int hh, int mm, int ss)
        {
            textBox1.Text = hh + " : " + mm + " : " + ss;
            return "Test of delegate";
        }

        private string TestOfDelegate2(int hh, int mm, int ss)
        {
            textBox2.Text = hh + " : " + mm + " : " + ss;
            return "Hello! How are you?";
        }

        private void button0_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

    }
}