//
//(c) Shinichiro Gondo  January 17, 2006
//
using System;
using System.Drawing;
using System.Windows.Forms;

namespace NatsukusayaSample2
{

	/// <summary>
	/// PhraseWritersWorkshop2 ̊Tv̐łB
	/// </summary>
	public class PhraseWritersWorkshop2:IPhraseWritersGroupE, IPhraseWritersGroupJ
	{
		public PhraseWritersWorkshop2(RichTextBox RTB)
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			richtextbox = RTB;
			richtextbox.Clear();
			iOfPhrase = 0;

		}

		private readonly RichTextBox richtextbox;
		private int iOfPhrase; 

		private void WritePhrase(string phrase, Color color)
		{
			richtextbox.AppendText(phrase);
			richtextbox.Select(iOfPhrase, phrase.Length);
			richtextbox.SelectionColor = color;
			iOfPhrase += phrase.Length;
		}

		// :IPhraseWritersGroupJ begin
		void IPhraseWritersGroupJ.WriteDots(string dots)
		{
			WritePhrase(dots, Color.Purple);
		}
		void IPhraseWritersGroupJ.WriteEscapeSequence(string es)
		{
			WritePhrase(es, Color.Black);
		}
		void IPhraseWritersGroupJ.WriteHiragana(string hiragana)
		{
			WritePhrase(hiragana, Color.Green);
		}
		void IPhraseWritersGroupJ.WriteKanji(string kanji)
		{
			WritePhrase(kanji, Color.Blue);
		}
		void IPhraseWritersGroupJ.WriteKatakana(string katakana)
		{
			WritePhrase(katakana, Color.Black);
		}
		void IPhraseWritersGroupJ.WriteNameJ(string nameJ)
		{
			WritePhrase(nameJ, Color.Brown);
		}
		void IPhraseWritersGroupJ.WriteNothing()
		{
			WritePhrase("", Color.Black);
		}
		//:IPhraseWritersGroupJ end

		//:IPhraseWritersGroupE begin
		void IPhraseWritersGroupE.WriteAdjective(string aj)
		{
			WritePhrase(aj, Color.Red);
		}
		void IPhraseWritersGroupE.WriteAdverb(string av)
		{
			WritePhrase(av, Color.Aqua);
		}
		void IPhraseWritersGroupE.WriteConjunction(string cj)
		{
			WritePhrase(cj, Color.Black);
		}
		void IPhraseWritersGroupE.WriteDefArticle(string da)
		{
			WritePhrase(da, Color.Aquamarine);
		}
		void IPhraseWritersGroupE.WriteDots(string dots)
		{
			WritePhrase(dots, Color.Salmon);
		}
		void IPhraseWritersGroupE.WriteInfArticle(string ia)
		{
			WritePhrase(ia, Color.Brown);
		}
		void IPhraseWritersGroupE.WriteNameE(string nE)
		{
			WritePhrase(nE, Color.Maroon);
		}
		void IPhraseWritersGroupE.WriteNothing()
		{
			WritePhrase("" , Color.DarkMagenta);
		}
		void IPhraseWritersGroupE.WriteNoun(string nn )
		{
			WritePhrase(nn , Color.Black);
		}
		void IPhraseWritersGroupE.WritePunctuationMarks(string pm )
		{
			WritePhrase(pm , Color.Green);
		}
		void IPhraseWritersGroupE.WritePronoun(string pn )
		{
			WritePhrase(pn , Color.Gray);
		}
		void IPhraseWritersGroupE.WriteProperNoun(string pN )
		{
			WritePhrase(pN , Color.Lavender);
		}
		void IPhraseWritersGroupE.WritePreposition(string pp )
		{
			WritePhrase(pp, Color.Magenta);
		}
		void IPhraseWritersGroupE.WriteRelatives(string rl)
		{
			WritePhrase(rl, Color.DarkKhaki);
		}
		void IPhraseWritersGroupE.WriteVerb(string vb)
		{
			WritePhrase(vb , Color.Navy);
		}
		void IPhraseWritersGroupE.WriteEscapeSequence(string es)
		{
			WritePhrase(es , Color.Black);
		}
		//:IPhraseWritersGroupE end


	}
}
